# Class BigQueryLoggerConfig

java.lang.Object
com.google.adk.plugins.agentanalytics.BigQueryLoggerConfig

public abstract class BigQueryLoggerConfig extends Object
Configuration for the BigQueryAgentAnalyticsPlugin.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `BigQueryLoggerConfig.Builder`
  Builder for `BigQueryLoggerConfig`.
  `static class`
  `BigQueryLoggerConfig.RetryConfig`
  Retry configuration for BigQuery writes.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BigQueryLoggerConfig()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `abstract boolean`
  `autoSchemaUpgrade()`
  `abstract Duration`
  `batchFlushInterval()`
  `abstract int`
  `batchSize()`
  `static BigQueryLoggerConfig.Builder`
  `builder()`
  `abstract com.google.common.collect.ImmutableList<String>`
  `clusteringFields()`
  `abstract Optional<String>`
  `connectionId()`
  `abstract @Nullable BiFunction<Object,String,Object>`
  `contentFormatter()`
  Optional custom formatter for content.
  `abstract boolean`
  `createViews()`
  `abstract @Nullable com.google.auth.Credentials`
  `credentials()`
  `abstract com.google.common.collect.ImmutableMap<String,Object>`
  `customTags()`
  `abstract String`
  `datasetId()`
  `abstract boolean`
  `enabled()`
  `abstract com.google.common.collect.ImmutableList<String>`
  `eventAllowlist()`
  `abstract com.google.common.collect.ImmutableList<String>`
  `eventDenylist()`
  `abstract String`
  `gcsBucketName()`
  `abstract String`
  `location()`
  `abstract boolean`
  `logMultiModalContent()`
  `abstract boolean`
  `logSessionMetadata()`
  `abstract int`
  `maxContentLength()`
  `abstract String`
  `projectId()`
  `abstract int`
  `queueMaxSize()`
  `abstract BigQueryLoggerConfig.RetryConfig`
  `retryConfig()`
  `abstract Duration`
  `shutdownTimeout()`
  `abstract String`
  `tableName()`
  `abstract BigQueryLoggerConfig.Builder`
  `toBuilder()`
  `abstract String`
  `viewPrefix()`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BigQueryLoggerConfig

    public BigQueryLoggerConfig()

- ## Method Details

  - ### enabled

    public abstract boolean enabled()

  - ### eventAllowlist

    public abstract com.google.common.collect.ImmutableList<String> eventAllowlist()

  - ### eventDenylist

    public abstract com.google.common.collect.ImmutableList<String> eventDenylist()

  - ### maxContentLength

    public abstract int maxContentLength()

  - ### location

    public abstract String location()

  - ### projectId

    public abstract String projectId()

  - ### datasetId

    public abstract String datasetId()

  - ### tableName

    public abstract String tableName()

  - ### clusteringFields

    public abstract com.google.common.collect.ImmutableList<String> clusteringFields()

  - ### logMultiModalContent

    public abstract boolean logMultiModalContent()

  - ### retryConfig

    public abstract BigQueryLoggerConfig.RetryConfig retryConfig()

  - ### batchSize

    public abstract int batchSize()

  - ### batchFlushInterval

    public abstract Duration batchFlushInterval()

  - ### shutdownTimeout

    public abstract Duration shutdownTimeout()

  - ### queueMaxSize

    public abstract int queueMaxSize()

  - ### contentFormatter

    public abstract @Nullable BiFunction<Object,String,Object> contentFormatter()
    Optional custom formatter for content.

    Allow plugins to modify the content before logging. This is useful for masking sensitive data, formatting content, etc.

    The contentFormatter must be thread-safe as it may be called concurrently across different agent invocations and fast/non-blocking to avoid adding latency to the agent's event processing pipeline.

    Important: To avoid corruption of the logs, the incoming content object should not be mutated. Modifying code should return a new copy of the object with desired changes.

  - ### gcsBucketName

    public abstract String gcsBucketName()

  - ### connectionId

    public abstract Optional<String> connectionId()

  - ### logSessionMetadata

    public abstract boolean logSessionMetadata()

  - ### customTags

    public abstract com.google.common.collect.ImmutableMap<String,Object> customTags()

  - ### autoSchemaUpgrade

    public abstract boolean autoSchemaUpgrade()

  - ### createViews

    public abstract boolean createViews()

  - ### viewPrefix

    public abstract String viewPrefix()

  - ### credentials

    public abstract @Nullable com.google.auth.Credentials credentials()

  - ### toBuilder

    public abstract BigQueryLoggerConfig.Builder toBuilder()

  - ### builder

    public static BigQueryLoggerConfig.Builder builder()